//: C06:CopyStrings2.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// Nahrazuje řetězce odpovídající predikátu.
#include <algorithm>
#include <cstddef>
#include <iostream>
#include <string>
using namespace std;

// predikát
bool obsahuje_i(const string& s) {
  return s.find('i') != string::npos;
}

int main() {
  string a[] = {"čti", "mé", "rty"};
  const size_t SIZE = sizeof a / sizeof a[0];
  string b[SIZE];
  string* endb = replace_copy_if(a, a + SIZE, b,
    obsahuje_i, string("polib"));
  string* beginb = b;
  while(beginb != endb)
    cout << *beginb++ << endl;
} ///:~
